diff --git a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
index 039a95ac7..7d210aca9 100644
--- a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
+++ b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerMP.java
@@ -4,6 +4,7 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.entity.player.PlayerLocalMultiplayer;
 import net.minecraft.client.net.handler.PacketHandlerClient;
 import net.minecraft.core.InventoryAction;
+import net.minecraft.core.block.Block;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.ArtType;
@@ -12,116 +13,122 @@ import net.minecraft.core.net.packet.*;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
-public class PlayerControllerMP extends PlayerController {
-
-	protected PacketHandlerClient netHandler;
-	protected int currentItem;
-
-	public PlayerControllerMP(Minecraft minecraft, PacketHandlerClient netHandler) {
-		super(minecraft);
-		
-		this.netHandler = netHandler;
-	}
-
-	@Override
-	public boolean destroyBlock(int x, int y, int z, @NotNull Side side, @NotNull Player player) {
-		int id = mc.currentWorld.getBlockId(x, y, z);
-		boolean removed = super.destroyBlock(x, y, z, side, player);
-		ItemStack item = mc.thePlayer.getCurrentEquippedItem();
-		if (item != null) {
-			item.onDestroyBlock(mc.currentWorld, id, x, y, z, side, mc.thePlayer);
-			if (item.stackSize <= 0) {
-				mc.thePlayer.destroyCurrentEquippedItem();
-			}
-		}
-		return removed;
-	}
-	
-	@Override
-	protected void hitBlock(int x, int y, int z, Side side, double xHit, double yHit) {
-		super.hitBlock(x, y, z, side, xHit, yHit);
-		netHandler.addToSendQueue(new PacketPlayerAction(PacketPlayerAction.ACTION_DIG_CONTINUED, x, y, z, side, xHit, yHit));
-	}
-	
-	@Override
-	public void sendStartDigPacket(int x, int y, int z, Side side, double xHit, double yHit) {
-		netHandler.addToSendQueue(new PacketPlayerAction(PacketPlayerAction.ACTION_DIG_START, x, y, z, side, xHit, yHit));
-	}
-	
-	@Override
-	public void sendDestroyBlockPacket(int x, int y, int z, Side side, double xHit, double yHit) {
-		netHandler.addToSendQueue(new PacketPlayerAction(PacketPlayerAction.ACTION_DIG_COMPLETE, x, y, z, side, xHit, yHit));
-	}
-	
-	@Override
-	protected void syncCurrentPlayItem() {
-		int i = mc.thePlayer.inventory.getCurrentSlot();
-		if (i != currentItem) {
-			currentItem = i;
-			netHandler.addToSendQueue(new PacketSetCarriedItem(currentItem));
-		}
-	}
-
-	@Override
-	public boolean useOrPlaceItemStackOnTile(Player entityplayer, World world, ItemStack itemstack, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
-		syncCurrentPlayItem();
-		netHandler.addToSendQueue(new PacketUseOrPlaceItemStack(blockX, blockY, blockZ, side.getDirection(), entityplayer.inventory.getCurrentItem(), xPlaced, yPlaced, PacketUseOrPlaceItemStack.TYPE_USE_OR_PLACE_ON_TILE));
-		return super.useOrPlaceItemStackOnTile(entityplayer, world, itemstack, blockX, blockY, blockZ, side, xPlaced, yPlaced);
-	}
-
-	@Override
-	public boolean useItemStackOnNothing(Player entityplayer, World world, ItemStack itemstack) {
-		syncCurrentPlayItem();
-		netHandler.addToSendQueue(new PacketUseOrPlaceItemStack(-1, -1, -1, Direction.NONE, entityplayer.inventory.getCurrentItem(), 0, 0, PacketUseOrPlaceItemStack.TYPE_USE_ON_NOTHING));
-		return super.useItemStackOnNothing(entityplayer, world, itemstack);
-	}
-
-	@Override
-	public boolean placeItemStackOnTile(Player entityplayer, World world, ItemStack itemstack, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
-		syncCurrentPlayItem();
-		netHandler.addToSendQueue(new PacketUseOrPlaceItemStack(blockX, blockY, blockZ, side.getDirection(), entityplayer.inventory.getCurrentItem(), xPlaced, yPlaced, PacketUseOrPlaceItemStack.TYPE_PLACE_ONLY));
-		return super.placeItemStackOnTile(entityplayer, world, itemstack, blockX, blockY, blockZ, side, xPlaced, yPlaced);
-	}
-
-	@Override
-	public Player createPlayer(World world) {
-		return new PlayerLocalMultiplayer(mc, world, mc.session, netHandler);
-	}
-
-	@Override
-	public void attack(@NotNull Player entityplayer, @NotNull Entity entity) {
-		syncCurrentPlayItem();
-		netHandler.addToSendQueue(new PacketEntityInteract(entityplayer.id, entity.id, PacketEntityInteract.ACTION_ATTACK));
-		entityplayer.attackTargetEntityWithCurrentItem(entity);
-	}
-
-	@Override
-	public boolean interact(Player entityplayer, Entity entity) {
-		syncCurrentPlayItem();
-		netHandler.addToSendQueue(new PacketEntityInteract(entityplayer.id, entity.id, PacketEntityInteract.ACTION_INTERACT));
-		return entityplayer.useCurrentItemOnEntity(entity);
-	}
-
-	@Override
-	public ItemStack handleInventoryMouseClick(int windowId, InventoryAction action, int[] args, Player entityplayer) {
-		short actionId = entityplayer.craftingInventory.backup(entityplayer.inventory);
-		ItemStack itemstack = super.handleInventoryMouseClick(windowId, action, args, entityplayer);
-		netHandler.addToSendQueue(new PacketContainerClick(windowId, action, args, itemstack, actionId));
-		return itemstack;
-	}
-
-	@Override
-	public void handleCloseInventory(int i, Player entityplayer) {
-		if (i == -9999) {
-        } else {
+import java.util.Objects;
+
+public class PlayerControllerMP
+    extends PlayerController {
+
+    protected @NotNull PacketHandlerClient packetHandler;
+    protected int currentSlot;
+
+    public PlayerControllerMP(final @NotNull Minecraft minecraft, final @NotNull PacketHandlerClient packetHandler) {
+        super(minecraft);
+
+        this.packetHandler = packetHandler;
+    }
+
+    @Override
+    public boolean destroyBlock(final @NotNull TilePosc tilePos, final @NotNull Side side) {
+        final @NotNull World world = Objects.requireNonNull(this.mc.currentWorld);
+        final @NotNull Player player = Objects.requireNonNull(this.mc.thePlayer);
+        final @NotNull Block<?> block = world.getBlockType(tilePos);
+
+        final boolean removed = super.destroyBlock(tilePos, side);
+        final @Nullable ItemStack item = player.getCurrentEquippedItem();
+        if (item != null) {
+            item.onBlockDestroyed(world, player, block, tilePos, side);
+            if (item.stackSize <= 0) {
+                player.destroyCurrentEquippedItem();
+            }
+        }
+        return removed;
+    }
+
+    @Override
+    protected void hitBlock(final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
+        super.hitBlock(tilePos, side, xHit, yHit);
+        this.packetHandler.addToSendQueue(new PacketPlayerAction(PacketPlayerAction.ACTION_DIG_CONTINUED, tilePos.x(), tilePos.y(), tilePos.z(), side, xHit, yHit));
+    }
+
+    @Override
+    public void sendStartDigPacket(final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
+        this.packetHandler.addToSendQueue(new PacketPlayerAction(PacketPlayerAction.ACTION_DIG_START, tilePos.x(), tilePos.y(), tilePos.z(), side, xHit, yHit));
+    }
+
+    @Override
+    public void sendDestroyBlockPacket(final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
+        this.packetHandler.addToSendQueue(new PacketPlayerAction(PacketPlayerAction.ACTION_DIG_COMPLETE, tilePos.x(), tilePos.y(), tilePos.z(), side, xHit, yHit));
+    }
+
+    @Override
+    protected void syncCurrentPlayItem() {
+        final int slot = Objects.requireNonNull(this.mc.thePlayer).inventory.getCurrentSlot();
+
+        if (slot != this.currentSlot) {
+            this.currentSlot = slot;
+            this.packetHandler.addToSendQueue(new PacketSetCarriedItem(this.currentSlot));
         }
-	}
+    }
+
+    @Override
+    public boolean useOrPlaceItemStackOnTile(final @NotNull Player player, final @NotNull World world, final @Nullable ItemStack itemStack, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xPlaced, final double yPlaced) {
+        this.syncCurrentPlayItem();
+        this.packetHandler.addToSendQueue(new PacketUseOrPlaceItemStack(tilePos.x(), tilePos.y(), tilePos.z(), side.getDirection(), player.inventory.getCurrentItem(), xPlaced, yPlaced, PacketUseOrPlaceItemStack.TYPE_USE_OR_PLACE_ON_TILE));
+        return super.useOrPlaceItemStackOnTile(player, world, itemStack, tilePos, side, xPlaced, yPlaced);
+    }
+
+    @Override
+    public boolean useItemStackOnNothing(final @NotNull Player player, final @NotNull World world, final @NotNull ItemStack itemStack) {
+        this.syncCurrentPlayItem();
+        this.packetHandler.addToSendQueue(new PacketUseOrPlaceItemStack(-1, -1, -1, Direction.NONE, player.inventory.getCurrentItem(), 0, 0, PacketUseOrPlaceItemStack.TYPE_USE_ON_NOTHING));
+        return super.useItemStackOnNothing(player, world, itemStack);
+    }
+
+    @Override
+    public boolean placeItemStackOnTile(final @NotNull Player player, final @NotNull World world, final @Nullable ItemStack itemStack, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xPlaced, final double yPlaced) {
+        this.syncCurrentPlayItem();
+        this.packetHandler.addToSendQueue(new PacketUseOrPlaceItemStack(tilePos.x(), tilePos.y(), tilePos.z(), side.getDirection(), player.inventory.getCurrentItem(), xPlaced, yPlaced, PacketUseOrPlaceItemStack.TYPE_PLACE_ONLY));
+        return super.placeItemStackOnTile(player, world, itemStack, tilePos, side, xPlaced, yPlaced);
+    }
+
+    @Override
+    public @NotNull Player createPlayer(final @NotNull World world) {
+        return new PlayerLocalMultiplayer(this.mc, world, Objects.requireNonNull(this.mc.session), this.packetHandler);
+    }
+
+    @Override
+    public void attack(final @NotNull Player player, final @NotNull Entity entity) {
+        this.syncCurrentPlayItem();
+        this.packetHandler.addToSendQueue(new PacketEntityInteract(player.id, entity.id, PacketEntityInteract.ACTION_ATTACK));
+        player.attackTargetEntityWithCurrentItem(entity);
+    }
+
+    @Override
+    public boolean interact(final @NotNull Player player, final @NotNull Entity entity) {
+        this.syncCurrentPlayItem();
+        this.packetHandler.addToSendQueue(new PacketEntityInteract(player.id, entity.id, PacketEntityInteract.ACTION_INTERACT));
+        return player.useCurrentItemOnEntity(entity);
+    }
+
+    @Override
+    public @Nullable ItemStack handleInventoryMouseClick(final int windowId, final @NotNull InventoryAction action, final int @Nullable [] args, final @NotNull Player player) {
+        final short actionId = player.containerMenu.backup(player.inventory);
+        final @Nullable ItemStack itemStack = super.handleInventoryMouseClick(windowId, action, args, player);
+        this.packetHandler.addToSendQueue(new PacketContainerClick(windowId, action, args, itemStack, actionId));
+        return itemStack;
+    }
+
+    @Override
+    public void handleCloseInventory(final int windowId, final @NotNull Player player) {
+        // Do nothing
+    }
 
-	@Override
-	public void setPaintingType(ArtType art)
-	{
-		netHandler.addToSendQueue(new PacketSetPaintingArt(art));
-	}
+    @Override
+    public void setPaintingType(final @NotNull ArtType art) {
+        this.packetHandler.addToSendQueue(new PacketSetPaintingArt(art));
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java
index 764cf9ece..f300416e3 100644
--- a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java
+++ b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerControllerSP.java
@@ -1,41 +1,54 @@
 package net.minecraft.client.player.controller;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Objects;
+
+public class PlayerControllerSP
+    extends PlayerController {
+
+    public PlayerControllerSP(final @NotNull Minecraft minecraft) {
+        super(minecraft);
+    }
+
+    @Override
+    public boolean destroyBlock(final @NotNull TilePosc tilePos, final @NotNull Side side) {
+        final @NotNull World world = Objects.requireNonNull(this.mc.currentWorld);
+        final @NotNull Player player = Objects.requireNonNull(this.mc.thePlayer);
+
+        if (!player.getGamemode().canInteract() || player.getHeldObject() != null) {
+            return false;
+        }
+
+        final @NotNull Block<?> block = world.getBlockType(tilePos);
+        final int data = world.getBlockData(tilePos);
+
+        final @Nullable TileEntity tileEntity = world.getTileEntity(tilePos);
+        final boolean removed = super.destroyBlock(tilePos, side);
+        final @Nullable ItemStack item = player.getCurrentEquippedItem();
+
+        if (item != null) {
+            item.onBlockDestroyed(world, player, block, tilePos, side);
+        }
+        if (removed && player.getGamemode().hasItemDrops()) {
+            block.onHarvest(world, player, tilePos, data, tileEntity);
+        }
+
+        if (item != null && item.stackSize <= 0) {
+            player.destroyCurrentEquippedItem();
+        }
+
+        return removed;
+    }
 
-public class PlayerControllerSP extends PlayerController {
-
-	public PlayerControllerSP(Minecraft minecraft) {
-		super(minecraft);
-	}
-
-	@Override
-	public boolean destroyBlock(int x, int y, int z, @NotNull Side side, @NotNull Player player) {
-		if (!player.getGamemode().canInteract() || mc.thePlayer.getHeldObject() != null) return false;
-		int id = mc.currentWorld.getBlockId(x, y, z);
-		int meta = mc.currentWorld.getBlockMetadata(x, y, z);
-		TileEntity tileEntity = mc.currentWorld.getTileEntity(x, y, z);
-		boolean removed = super.destroyBlock(x, y, z, side, player);
-		ItemStack item = mc.thePlayer.getCurrentEquippedItem();
-
-		if (item != null) {
-			item.onDestroyBlock(mc.currentWorld, id, x, y, z, side, mc.thePlayer);
-		}
-		if (removed && mc.thePlayer.getGamemode().hasItemDrops()) {
-			Blocks.blocksList[id].harvestBlock(mc.currentWorld, mc.thePlayer, x, y, z, meta, tileEntity);
-		}
-
-		if (item != null && item.stackSize <= 0)
-		{
-			mc.thePlayer.destroyCurrentEquippedItem();
-		}
-
-		return removed;
-	}
-	
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/EntityRendererDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/EntityRendererDispatcher.java
index 3ac8e1ae0..0b47c55be 100644
--- a/game/client/src/main/java/net/minecraft/client/render/EntityRendererDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/EntityRendererDispatcher.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.render;
 
-import java.util.HashMap;
 import java.util.Map;
 
+import it.unimi.dsi.fastutil.objects.Object2ObjectOpenHashMap;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.entity.*;
 import net.minecraft.client.render.font.FontRenderer;
@@ -41,13 +41,11 @@ public final class EntityRendererDispatcher {
     public static double renderPosY = 0;
     public static double renderPosZ = 0;
 
-    private final @NotNull Map<@NotNull Class<? extends Entity>, @Nullable EntityRenderer<? extends Entity>> renderers;
+    private final @NotNull Map<@NotNull Class<? extends Entity>, @Nullable EntityRenderer<? extends Entity>> renderers = new Object2ObjectOpenHashMap<>();
     public final @NotNull TextureManager textureManager;
     public final @NotNull TexturePackList packList;
     public final @NotNull FontRenderer font;
     public final @NotNull GameSettings settings;
-    public @Nullable World world;
-    public @Nullable ICamera camera;
     public float viewLerpYaw = 0;
     public float viewLerpPitch = 0;
     public double viewLerpPosX = 0;
@@ -60,8 +58,6 @@ public final class EntityRendererDispatcher {
         this.packList = mc.texturePackList;
         this.font = mc.font;
         this.settings = mc.gameSettings;
-
-        this.renderers = new HashMap<>();
         reload();
     }
 
@@ -127,15 +123,14 @@ public final class EntityRendererDispatcher {
         return (EntityRenderer<T>) getRenderer(entity.getClass());
     }
 
-    public void cacheActiveRenderInfo(final @NotNull World world, final @NotNull ICamera camera, final float partialTick) {
-        if (this.world != world) {
-            for (final @Nullable EntityRenderer<?> renderer : this.renderers.values()) {
-                if (renderer == null) continue;
-                renderer.onWorldChanged(world);
-            }
+    public void onWorldChanged(@NotNull World world) {
+        for (final @Nullable EntityRenderer<?> renderer : this.renderers.values()) {
+            if (renderer == null) continue;
+            renderer.onWorldChanged(world);
         }
-        this.world = world;
-        this.camera = camera;
+    }
+
+    public void cacheActiveRenderInfo(final @NotNull ICamera camera, final float partialTick) {
         this.viewLerpYaw = (float) camera.getYRot(partialTick);
         this.viewLerpPitch = (float) camera.getXRot(partialTick);
         this.viewLerpPosX = camera.getX(partialTick);
@@ -143,7 +138,7 @@ public final class EntityRendererDispatcher {
         this.viewLerpPosZ = camera.getZ(partialTick);
     }
 
-    public <T extends Entity> void renderEntity(final TessellatorGeneral tessellator, final T entity, final float partialTick) {
+    public <T extends Entity> void renderEntity(final @NotNull TessellatorGeneral tessellator, final @NotNull T entity, final float partialTick) {
         final double lerpPosX = entity.xo + (entity.x - entity.xo) * (double) partialTick;
         final double lerpPosY = entity.yo + (entity.y - entity.yo) * (double) partialTick;
         final double lerpPosZ = entity.zo + (entity.z - entity.zo) * (double) partialTick;
diff --git a/game/client/src/main/java/net/minecraft/client/render/LightingCache.java b/game/client/src/main/java/net/minecraft/client/render/LightingCache.java
index bbb159fe4..bcbc65d37 100644
--- a/game/client/src/main/java/net/minecraft/client/render/LightingCache.java
+++ b/game/client/src/main/java/net/minecraft/client/render/LightingCache.java
@@ -2,7 +2,6 @@ package net.minecraft.client.render;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
@@ -25,7 +24,7 @@ final public class LightingCache {
 
     private final @NotNull TilePos offset = new TilePos(Integer.MAX_VALUE, Integer.MAX_VALUE, Integer.MAX_VALUE);
 
-    private Block<?> block;
+    private @NotNull Block<?> block;
     private WorldSource access;
     private final @NotNull TilePos queryPos = new TilePos();
 
@@ -46,8 +45,7 @@ final public class LightingCache {
     }
 
     private float calcBrightness(final @NotNull TilePos tilePos) {
-        final int blockId = this.access.getBlockId(tilePos);
-        final Block<?> block = Blocks.getBlock(blockId);
+        final Block<?> block = this.access.getBlockType(tilePos);
 
         if (this.block.emission >= 15) {
             return 1.0f;
@@ -55,9 +53,6 @@ final public class LightingCache {
         if (!this.mc.isAmbientOcclusionEnabled()) {
             return 1.0f;
         }
-        if (block == null) {
-            return 1.0f;
-        }
         return 1.0f - block.getAmbientOcclusionStrength(this.access, tilePos);
     }
 
@@ -75,7 +70,7 @@ final public class LightingCache {
     public boolean getOpacity(int relX, int relY, int relZ) {
         int index = (relX + CACHE_RANGE) * CACHE_SIZE * CACHE_SIZE + (relY + CACHE_RANGE) * CACHE_SIZE + (relZ + CACHE_RANGE);
         if (!bitGet(this.opacityCached, index)) {
-            this.opacityValue = bitSetState(this.opacityValue, index, Blocks.solid[this.access.getBlockId(this.offset.add(relX, relY, relZ, this.queryPos))]);
+            this.opacityValue = bitSetState(this.opacityValue, index, this.access.getBlockType(this.offset.add(relX, relY, relZ, this.queryPos)).solid());
             this.opacityCached = bitSet(this.opacityCached, index);
         }
         return bitGet(this.opacityValue, index);
